const express = require('express');
const router = express.Router();
const bodyParser = require('body-parser');
const loginController = require("../controllers/loginController");
const dvrController =require("../controllers/dvrReportController");
const auth = require("../middlewares/authorize");


router.use(bodyParser.urlencoded({ extended: true }))
router.use(bodyParser.json());

router.post("/api/signupuser", loginController.signupuser);
router.post("/api/loginuser", loginController.loginUser);
router.get("/api/getselectionData",auth,dvrController.getselectionData);


router.post("/api/createContactEntry",auth,dvrController.createContactEntry);


router.get("/api/getdvrdetails",auth,dvrController.getdvrDetails);
router.get("/api/getdashboarddetails",auth,dvrController.getdashboarddetails);

router.post("/api/createDvrEntry",auth,dvrController.createDvrEntry);
router.put("/api/updateDvrEntry",auth,dvrController.updatedvrDetails);

router.post("/api/userrolemap",auth ,loginController.userrolemap);

router.post("/api/createCustomerEntry",auth,dvrController.createCustomerentry);

router.put("/api/updateContactDetails",auth,dvrController.updateContactDetails);
router.put("/api/updateCustomerDetails",auth,dvrController.updateCustomerDetails);
router.get("/api/getlastestdvr",auth,dvrController.getlastestdvr);

router.get("/api/getcontactdetails",auth,dvrController.getcontactDetails);

router.get("/api/getsalepersonlist",auth,dvrController.getsalePersonList);

router.get("/api/getcustcontactdetails",auth,dvrController.getCustcontactDetails);
router.post("/api/createUpdateCustomerentry",auth,dvrController.createUpdateCustomerentry);

router.post("/api/deletedvrEntry",auth,dvrController.deletedvrEntry);




module.exports = router;
